"""
6.s090
Read / Write States
"""

import csv
import numpy as np
# no additional imports allowed

def load_database(filename):
    """
    Reads the database from the given CSV file and processes it into a list of lists.
    NOTE: Skip the header!
    
    Parameters:
        * filename (str) : database file to be read

    Returns:
        * database (list) : a list where each element is a list of the form
            [
             origin_state (str),
             destination_state (str),
             item (str),
             transportation (str),
             value (int),
            ]
    """
    pass # your code here

def unique_destinations(database, state):
    """
    Given an origin state, return the number of unique states it exported 
    items to.

    Parameters:
        * database (list) : a list where each element is a list of the form
            described above.

    Returns:
        An integer representing the number of unique states.
    """

    pass # your code here

def transform_dict(database):
    """
    Transforms the database into a dictionary mapping origin_states to a
    list of values of transactions the state exported. Only includes 
    transactions where the origin is different from the destination.

    Parameters:
        * database (list) : a list where each element is a list of the form
            described above.

    Returns:
        A dictionary with keys that are origin_states and values that are a
        list of numbers of all outbound transaction values.
            {origin_state (str) : [value1, value2, ...]}
    """

    pass # your code here


############## WRITE STATES EXERCISES:

def make_rows(database):
    """
    Transforms the database into a list of lists of rows containing
    ["State", "Total Exports Value", "# Export Transactions", 
    "Average ETV", "Median ETV", "ETV std"], starting with the given header
    and listing states in alphabetical order.

    Parameters:
        * database (list) : a list where each element is a list of the form
            described above.

    Returns:
        A list of lists containing the desired values.
    """
    pass # your code here



def write_database(filename, rows):
    """
    Given rows of a database, write it to the given CSV file.

    Parameters:
        * filename (str) : database file to be read
        * rows (list<list<(str, int, float)>>): rows output by make_rows

    """
    pass # your code here



if __name__ == '__main__':
    # These are the same databases used in the test.py file:
    tiny_database = load_database('resources/tiny_transactions.csv')
    large_database = load_database('resources/large_transactions.csv')
    small_database = large_database[:20]
    medium_database = large_database[:1000]
    ########################################################################
    # Your code below:
